#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/time.h>
#include <termios.h>  
#include <errno.h>

#define NUMPKT 32

char *pkts[NUMPKT];
int fd;

char *devname="/dev/ttyS2";
int delay = 60;

void initPackets() {
  /* Furby and Furbybaby */
  pkts[0] = strdup("\xEF\xEF\xEF\xEF\xEF\xFF\xFF\xFF\xFF");
  pkts[1] = strdup("\xEF\xEF\xEF\xEF\xFF\xFF\xFF\xFF\xEF");
  pkts[2] = strdup("\xEF\xEF\xEF\xFF\xEF\xFF\xFF\xEF\xFF");
  pkts[3] = strdup("\xEF\xEF\xEF\xFF\xFF\xFF\xFF\xEF\xEF");
  pkts[4] = strdup("\xEF\xEF\xFF\xEF\xEF\xFF\xEF\xFF\xFF");
  pkts[5] = strdup("\xEF\xEF\xFF\xEF\xFF\xFF\xEF\xFF\xEF");
  pkts[6] = strdup("\xEF\xEF\xFF\xFF\xEF\xFF\xEF\xEF\xFF");
  pkts[7] = strdup("\xEF\xEF\xFF\xFF\xFF\xFF\xEF\xEF\xEF");
  pkts[8] = strdup("\xEF\xFF\xEF\xEF\xEF\xEF\xFF\xFF\xFF");
  pkts[9] = strdup("\xEF\xFF\xEF\xEF\xFF\xEF\xFF\xFF\xEF");
  pkts[10] = strdup("\xEF\xFF\xEF\xFF\xEF\xEF\xFF\xEF\xFF");
  pkts[11] = strdup("\xEF\xFF\xEF\xFF\xFF\xEF\xFF\xEF\xEF");
  pkts[12] = strdup("\xEF\xFF\xFF\xEF\xEF\xEF\xEF\xFF\xFF");
  pkts[13] = strdup("\xEF\xFF\xFF\xEF\xFF\xEF\xEF\xFF\xEF");
  pkts[14] = strdup("\xEF\xFF\xFF\xFF\xEF\xEF\xEF\xEF\xFF");
  pkts[15] = strdup("\xEF\xFF\xFF\xFF\xFF\xEF\xEF\xEF\xEF");
  /* Furbybaby */
  pkts[16] = strdup("\xEF\xEF\xEF\xEF\xEF\xEF\xEF\xEF\xEF");
  pkts[17] = strdup("\xEF\xEF\xEF\xEF\xFF\xEF\xEF\xEF\xFF");
  pkts[18] = strdup("\xEF\xEF\xEF\xFF\xEF\xEF\xEF\xFF\xEF");
  pkts[19] = strdup("\xEF\xEF\xEF\xFF\xFF\xEF\xEF\xFF\xFF");
  pkts[20] = strdup("\xEF\xEF\xFF\xEF\xEF\xEF\xFF\xEF\xEF");
  pkts[21] = strdup("\xEF\xEF\xFF\xEF\xFF\xEF\xFF\xEF\xFF");
  pkts[22] = strdup("\xEF\xEF\xFF\xFF\xEF\xEF\xFF\xFF\xEF");
  pkts[23] = strdup("\xEF\xEF\xFF\xFF\xFF\xEF\xFF\xFF\xFF");
  pkts[24] = strdup("\xEF\xFF\xEF\xEF\xEF\xFF\xEF\xEF\xEF");
  pkts[25] = strdup("\xEF\xFF\xEF\xEF\xFF\xFF\xEF\xEF\xFF");
  pkts[26] = strdup("\xEF\xFF\xEF\xFF\xEF\xFF\xEF\xFF\xEF");
  pkts[27] = strdup("\xEF\xFF\xEF\xFF\xFF\xFF\xEF\xFF\xFF");
  pkts[28] = strdup("\xEF\xFF\xFF\xEF\xEF\xFF\xFF\xEF\xEF");
  pkts[29] = strdup("\xEF\xFF\xFF\xEF\xFF\xFF\xFF\xEF\xFF");
  pkts[30] = strdup("\xEF\xFF\xFF\xFF\xEF\xFF\xFF\xFF\xEF");
  pkts[31] = strdup("\xEF\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF");
}

void sendPkt(int num) {
  int i;
  for (i=0; i<6 ;i++) {
   write (fd,pkts[num],9);
   usleep(delay);
  }
}

main()
{
 int i;
 struct termios newtio;
 
 /* Setup furby data packets */
 initPackets();
 
 /* Open serial device */
 if ((fd = open(devname, O_RDWR | O_NOCTTY | O_NDELAY ))==-1) {
  perror("open()");
  return(-1);
 }

 /* Configure port 4800baud 8N0 */
 bzero(&newtio, sizeof(newtio)); 
 newtio.c_cflag = B4800 | CS8 | CLOCAL;
 newtio.c_iflag = IGNPAR;
 newtio.c_oflag = 0;
 newtio.c_lflag = 0;
 newtio.c_cc[VTIME]    = 0;     /* inter-character timer unused */
 newtio.c_cc[VMIN]     = 1;     /* blocking read until 1 character arrives */
 tcflush(fd, TCIFLUSH);
 tcsetattr(fd,TCSANOW,&newtio);

 while (1) {
  printf ("Packet number: ");
  scanf ("%i",&i);
  i = (i % NUMPKT);
  printf ("Sending packet %i ...\n",i); 
  sendPkt(i);
 } 
}
